diff --git a/src/backend/storage/smgr/page_compression.c b/src/backend/storage/smgr/page_compression.c
new file mode 100644
index 0000000000..86cb3eefc4
--- /dev/null
+++ b/src/backend/storage/smgr/page_compression.c
@@ -0,0 +1,399 @@
+/*
+ * page_compression.c
+ *		Routines for page compression
+ *
+ * There are two implementations at the moment: zstd, and the Postgres
+ * pg_lzcompress(). zstd support requires that the server was compiled
+ * with --with-zstd.
+ *
+ * Copyright (c) 2020, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/backend/storage/smgr/page_compression.c
+ */
+#include "postgres.h"
+#include "miscadmin.h"
+#include "catalog/pg_type.h"
+#include "utils/array.h"
+#include "utils/datum.h"
+#include "utils/relcache.h"
+
+#include "utils/timestamp.h"
+#include "storage/bufmgr.h"
+#include "storage/page_compression.h"
+#include "storage/page_compression_impl.h"
+
+int compress_address_flush_chunks;
+
+/**
+ * buildCompressReloptions() -- build compression option array from PageCompressOpts
+ * 
+ */
+Datum
+buildCompressReloptions(PageCompressOpts *pcOpt)
+{
+	Datum		result;
+	ArrayBuildState *astate;
+	text		*t;
+	char		*value;
+	Size		len;
+
+	/* We build new array using accumArrayResult */
+	astate = NULL;
+
+	/* compresstype */
+	value = NULL;
+	switch (pcOpt->compresstype)
+	{
+		case COMPRESS_TYPE_PGLZ:
+			value = "pglz";
+			break;
+
+		case COMPRESS_TYPE_ZSTD:
+			value = "zstd";
+			break;
+		
+		default:
+			break;
+	}
+
+	if(value != NULL)
+	{
+		len = VARHDRSZ + strlen("compresstype") + 1 + strlen(value);
+
+		/* +1 leaves room for sprintf's trailing null */
+		t = (text *) palloc(len + 1);
+		SET_VARSIZE(t, len);
+		sprintf(VARDATA(t), "compresstype=%s", value);
+
+		astate = accumArrayResult(astate, PointerGetDatum(t),
+									false, TEXTOID,
+									CurrentMemoryContext);
+	}
+
+	/* compresslevel */
+	if(pcOpt->compresslevel != 0)
+	{
+		value = psprintf("%d",pcOpt->compresslevel);
+
+		len = VARHDRSZ + strlen("compresslevel") + 1 + strlen(value);
+
+		/* +1 leaves room for sprintf's trailing null */
+		t = (text *) palloc(len + 1);
+		SET_VARSIZE(t, len);
+		sprintf(VARDATA(t), "compresslevel=%s", value);
+		pfree(value);
+
+		astate = accumArrayResult(astate, PointerGetDatum(t),
+									false, TEXTOID,
+									CurrentMemoryContext);
+	}
+
+	/* compresslevel */
+	if(pcOpt->compress_chunk_size != BLCKSZ / 2)
+	{
+		value = psprintf("%d",pcOpt->compress_chunk_size);
+
+		len = VARHDRSZ + strlen("compress_chunk_size") + 1 + strlen(value);
+
+		/* +1 leaves room for sprintf's trailing null */
+		t = (text *) palloc(len + 1);
+		SET_VARSIZE(t, len);
+		sprintf(VARDATA(t), "compress_chunk_size=%s", value);
+		pfree(value);
+
+		astate = accumArrayResult(astate, PointerGetDatum(t),
+									false, TEXTOID,
+									CurrentMemoryContext);
+	}
+
+	/* compresslevel */
+	if(pcOpt->compress_prealloc_chunks != 0)
+	{
+		value = psprintf("%d",pcOpt->compress_prealloc_chunks);
+
+		len = VARHDRSZ + strlen("compress_prealloc_chunks") + 1 + strlen(value);
+
+		/* +1 leaves room for sprintf's trailing null */
+		t = (text *) palloc(len + 1);
+		SET_VARSIZE(t, len);
+		sprintf(VARDATA(t), "compress_prealloc_chunks=%s", value);
+		pfree(value);
+
+		astate = accumArrayResult(astate, PointerGetDatum(t),
+									false, TEXTOID,
+									CurrentMemoryContext);
+	}
+
+	if (astate)
+		result = makeArrayResult(astate, CurrentMemoryContext);
+	else
+		result = (Datum) 0;
+
+	return result;
+}
+
+void
+check_and_repair_compress_address(PageCompressHeader *pcMap, uint16 chunk_size, uint8 algorithm, const char *path)
+{
+	int i, unused_chunks;
+	BlockNumber blocknum, max_blocknum, max_nonzero_blocknum;
+	uint32 nblocks, allocated_chunks;
+	pc_chunk_number_t max_allocated_chunkno;
+	BlockNumber *global_chunknos;
+	char last_recovery_start_time_buf[sizeof(TimestampTz)];
+	char start_time_buf[sizeof(TimestampTz)];
+	bool need_check = false;
+
+	unused_chunks = 0;
+	max_blocknum = (BlockNumber) -1;
+	max_nonzero_blocknum = (BlockNumber) -1;
+	max_allocated_chunkno = (pc_chunk_number_t) 0;
+
+	/* if the relation had been checked in this startup, skip */
+	memcpy(last_recovery_start_time_buf, &pcMap->last_recovery_start_time,sizeof(TimestampTz));
+	memcpy(start_time_buf, &PgStartTime,sizeof(TimestampTz));
+	for(i=0; i < sizeof(TimestampTz); i++)
+	{
+		if(start_time_buf[i] != last_recovery_start_time_buf[i])
+		{
+			need_check = true;
+			break;
+		}
+	}
+	if(!need_check)
+		return;
+
+	/* check head of compress address file */
+	if(pcMap->chunk_size != chunk_size || pcMap->algorithm != algorithm)
+	{
+		/* reinitialize compress head if it's invalid and zero_damaged_pages is on */
+		if(zero_damaged_pages)
+		{
+			ereport(WARNING,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunk_size %u or algorithm %u in head of compress relation address file \"%s\", and reinitialized it.",
+							 pcMap->chunk_size, pcMap->algorithm, path)));
+
+			pcMap->algorithm = algorithm;
+			pg_atomic_write_u32(&pcMap->nblocks, RELSEG_SIZE);
+			pg_atomic_write_u32(&pcMap->allocated_chunks, 0);
+			pg_atomic_write_u32(&pcMap->last_synced_allocated_chunks, 0);
+			pcMap->chunk_size = chunk_size;
+		}
+		else
+			ereport(ERROR,
+					(errcode(ERRCODE_DATA_CORRUPTED),
+					 errmsg("invalid chunk_size %u or algorithm %u in head of compress relation address file \"%s\"",
+							 pcMap->chunk_size, pcMap->algorithm, path)));
+	}
+
+	nblocks = pg_atomic_read_u32(&pcMap->nblocks);
+	allocated_chunks = pg_atomic_read_u32(&pcMap->allocated_chunks);
+	global_chunknos = palloc0(MAX_CHUNK_NUMBER(chunk_size));
+
+	/* check compress address of every pages */
+	for(blocknum = 0; blocknum < (BlockNumber)RELSEG_SIZE; blocknum++)
+	{
+		PageCompressAddr *pcAddr = GetPageCompressAddr(pcMap, chunk_size, blocknum);
+
+		/* skip when found first zero filled block after nblocks */
+		/*if(blocknum >= (BlockNumber)nblocks && pcAddr->allocated_chunks == 0)
+			break;*/
+
+		/* check allocated_chunks for one page */
+		if(pcAddr->allocated_chunks > BLCKSZ / chunk_size)
+		{
+			if(zero_damaged_pages)
+			{
+				MemSet(pcAddr, 0, SizeOfPageCompressAddr(chunk_size));
+				ereport(WARNING,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("invalid allocated_chunks %u of block %u in file \"%s\", and zero this block",
+								 pcAddr->allocated_chunks, blocknum, path)));
+				continue;
+			}
+			else
+			{
+				pfree(global_chunknos);
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("invalid allocated_chunks %u of block %u in file \"%s\"",
+								 pcAddr->allocated_chunks, blocknum, path)));
+			}
+		}
+
+		/* check chunknos for one page */
+		for(i = 0; i< pcAddr->allocated_chunks; i++)
+		{
+			/* check for invalid chunkno */
+			if(pcAddr->chunknos[i] == 0 || pcAddr->chunknos[i] > MAX_CHUNK_NUMBER(chunk_size))
+			{
+				if (zero_damaged_pages)
+				{
+					MemSet(pcAddr, 0, SizeOfPageCompressAddr(chunk_size));
+					ereport(WARNING,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("invalid chunk number %u of block %u in file \"%s\", and zero this block",
+									 pcAddr->chunknos[i], blocknum, path)));
+					continue;
+				}
+				else
+				{
+					pfree(global_chunknos);
+					ereport(ERROR,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("invalid chunk number %u of block %u in file \"%s\"",
+									 pcAddr->chunknos[i], blocknum, path)));
+				}
+			}
+
+			/* check for duplicate chunkno */
+			if(global_chunknos[pcAddr->chunknos[i] - 1] !=0 )
+			{
+				if (zero_damaged_pages)
+				{
+					MemSet(pcAddr, 0, SizeOfPageCompressAddr(chunk_size));
+					ereport(WARNING,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("chunk number %u of block %u duplicate with block %u in file \"%s\", and zero this block",
+									 pcAddr->chunknos[i], blocknum, global_chunknos[pcAddr->chunknos[i] - 1], path)));
+					continue;
+				}
+				else
+				{
+					pfree(global_chunknos);
+					ereport(ERROR,
+							(errcode(ERRCODE_DATA_CORRUPTED),
+							 errmsg("chunk number %u of block %u duplicate with block %u in file \"%s\"",
+									 pcAddr->chunknos[i], blocknum, global_chunknos[pcAddr->chunknos[i]], path)));
+				}
+			}
+		}
+
+		/* clean chunknos beyond allocated_chunks for one page */
+		for(i = pcAddr->allocated_chunks; i< BLCKSZ / chunk_size; i++)
+		{
+			if(pcAddr->chunknos[i] != 0)
+			{
+				pcAddr->chunknos[i] = 0;
+				ereport(WARNING,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("clear chunk number %u beyond allocated_chunks %u of block %u in file \"%s\"",
+								 pcAddr->chunknos[i], pcAddr->allocated_chunks, blocknum, path)));
+			}
+		}
+
+		/* check nchunks for one page */
+		if(pcAddr->nchunks > pcAddr->allocated_chunks)
+		{
+			if(zero_damaged_pages)
+			{
+				MemSet(pcAddr, 0, SizeOfPageCompressAddr(chunk_size));
+				ereport(WARNING,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("nchunks %u exceeds allocated_chunks %u of block %u in file \"%s\", and zero this block",
+								 pcAddr->nchunks, pcAddr->allocated_chunks, blocknum, path)));
+				continue;
+			}
+			else
+			{
+				pfree(global_chunknos);
+				ereport(ERROR,
+						(errcode(ERRCODE_DATA_CORRUPTED),
+						 errmsg("nchunks %u exceeds allocated_chunks %u of block %u in file \"%s\"",
+								 pcAddr->nchunks, pcAddr->allocated_chunks, blocknum, path)));	
+			}
+		}
+
+		max_blocknum = blocknum;
+		if(pcAddr->nchunks > 0)
+			max_nonzero_blocknum = blocknum;
+
+		for(i = 0; i < pcAddr->allocated_chunks; i++)
+		{
+			global_chunknos[pcAddr->chunknos[i] -1 ] = blocknum + 1;
+			if(pcAddr->chunknos[i] > max_allocated_chunkno)
+				max_allocated_chunkno = pcAddr->chunknos[i];
+		}
+	}
+
+	/* check for holes in allocated chunks*/
+	for(i = 0; i < max_allocated_chunkno; i++)
+		if(global_chunknos[i] == 0)
+			unused_chunks ++;
+
+	if(unused_chunks > 0)
+		ereport(WARNING,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("there are %u chunks of total allocated chunks %u can not be use in file \"%s\"",
+						unused_chunks, max_allocated_chunkno, path),
+				 errhint("You may need to run VACUMM FULL to optimize space allocation, or run REINDEX if it is an index.")));
+
+	/* update nblocks in head of compressed file */
+	if(nblocks < max_nonzero_blocknum + 1)
+	{
+		pg_atomic_write_u32(&pcMap->nblocks, max_nonzero_blocknum + 1);
+		pg_atomic_write_u32(&pcMap->last_synced_nblocks, max_nonzero_blocknum + 1);
+
+		ereport(WARNING,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("update nblocks head of compressed file \"%s\". old: %u, new: %u",
+						 path, nblocks, max_nonzero_blocknum + 1)));
+	}
+
+	/* update allocated_chunks in head of compress file */
+	if(allocated_chunks != max_allocated_chunkno)
+	{
+		pg_atomic_write_u32(&pcMap->allocated_chunks, max_allocated_chunkno);
+		pg_atomic_write_u32(&pcMap->last_synced_allocated_chunks, max_allocated_chunkno);
+
+		ereport(WARNING,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("update allocated_chunks in head of compressed file \"%s\". old: %u, new: %u",
+						 path, allocated_chunks, max_allocated_chunkno)));
+	}
+
+	/* clean compress address after max_blocknum + 1 */
+	for(blocknum = max_blocknum + 1; blocknum < (BlockNumber)RELSEG_SIZE; blocknum++)
+	{
+		char buf[128], *p;
+		PageCompressAddr *pcAddr = GetPageCompressAddr(pcMap, chunk_size, blocknum);
+
+		/* skip zero block */
+		if(pcAddr->allocated_chunks == 0 && pcAddr->nchunks == 0)
+			continue;
+
+		/* clean compress address and output content of the address */
+		MemSet(buf, 0, sizeof(buf));
+		p = buf;
+
+		for(i = 0; i< pcAddr->allocated_chunks; i++)
+		{
+			if(pcAddr->chunknos[i])
+			{
+				if(i==0)
+					snprintf(p, (sizeof(buf) - (p - buf)), "%u", pcAddr->chunknos[i]);
+				else
+					snprintf(p, (sizeof(buf) - (p - buf)), ",%u", pcAddr->chunknos[i]);
+				p += strlen(p);
+			}
+		}
+
+		MemSet(pcAddr, 0, SizeOfPageCompressAddr(chunk_size));
+		ereport(WARNING,
+				(errcode(ERRCODE_DATA_CORRUPTED),
+				 errmsg("clean unused compress address of block %u in file \"%s\", old allocated_chunks/nchunks/chunknos: %u/%u/{%s}",
+						 blocknum, path, pcAddr->allocated_chunks, pcAddr->nchunks, buf)));
+	}
+
+	pfree(global_chunknos);
+
+	if(pc_msync(pcMap) != 0)
+		ereport(data_sync_elevel(ERROR),
+				(errcode_for_file_access(),
+					errmsg("could not msync file \"%s\": %m",
+						path)));
+
+	pcMap->last_recovery_start_time = PgStartTime;
+}
\ No newline at end of file
diff --git a/src/backend/utils/adt/dbsize.c b/src/backend/utils/adt/dbsize.c
index 3319e9761e..bbffde6239 100644
--- a/src/backend/utils/adt/dbsize.c
+++ b/src/backend/utils/adt/dbsize.c
@@ -292,16 +292,58 @@ calculate_relation_size(RelFileNode *rfn, BackendId backend, ForkNumber forknum)
 			snprintf(pathname, MAXPGPATH, "%s.%u",
 					 relationpath, segcount);
 
-		if (stat(pathname, &fst) < 0)
+		if(rfn->compress_algorithm != COMPRESS_TYPE_NONE &&
+			forknum == MAIN_FORKNUM)
 		{
-			if (errno == ENOENT)
-				break;
-			else
-				ereport(ERROR,
-						(errcode_for_file_access(),
-						 errmsg("could not stat file \"%s\": %m", pathname)));
+			char	*pcfile_segpath;
+
+			/* calculate size of page compression address file */
+			pcfile_segpath = psprintf("%s_pca", pathname);
+			if (stat(pcfile_segpath, &fst) < 0)
+			{
+				if (errno == ENOENT)
+				{
+					pfree(pcfile_segpath);
+					break;
+				}
+				else
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							errmsg("could not stat file \"%s\": %m", pcfile_segpath)));
+			}
+			totalsize += fst.st_size;
+			pfree(pcfile_segpath);
+
+			/* calculate size of page compression data file */
+			pcfile_segpath = psprintf("%s_pcd", pathname);
+			if (stat(pcfile_segpath, &fst) < 0)
+			{
+				if (errno == ENOENT)
+				{
+					pfree(pcfile_segpath);
+					break;
+				}
+				else
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							errmsg("could not stat file \"%s\": %m", pcfile_segpath)));
+			}
+			totalsize += fst.st_size;
+			pfree(pcfile_segpath);
+		}
+		else
+		{
+			if (stat(pathname, &fst) < 0)
+			{
+				if (errno == ENOENT)
+					break;
+				else
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							errmsg("could not stat file \"%s\": %m", pathname)));
+			}
+			totalsize += fst.st_size;
 		}
-		totalsize += fst.st_size;
 	}
 
 	return totalsize;
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index 9061af81a3..772d558b83 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -30,6 +30,10 @@
 #include <fcntl.h>
 #include <unistd.h>
 
+#include "access/hash.h"
+#include "access/gin_private.h"
+#include "access/gist_private.h"
+#include "access/spgist_private.h"
 #include "access/htup_details.h"
 #include "access/multixact.h"
 #include "access/nbtree.h"
@@ -74,6 +78,7 @@
 #include "rewrite/rewriteDefine.h"
 #include "rewrite/rowsecurity.h"
 #include "storage/lmgr.h"
+#include "storage/page_compression.h"
 #include "storage/smgr.h"
 #include "utils/array.h"
 #include "utils/builtins.h"
@@ -295,6 +300,7 @@ static OpClassCacheEnt *LookupOpclassInfo(Oid operatorClassOid,
 										  StrategyNumber numSupport);
 static void RelationCacheInitFileRemoveInDir(const char *tblspcpath);
 static void unlink_initfile(const char *initfilename, int elevel);
+static void SetupPageCompressForRelation(Relation relation, PageCompressOpts *compress_options);
 
 
 /*
@@ -1337,6 +1343,40 @@ RelationInitPhysicalAddr(Relation relation)
 		else
 			relation->rd_firstRelfilenodeSubid = InvalidSubTransactionId;
 	}
+
+	/* setup page compression option */
+	if(relation->rd_options)
+	{
+		switch(relation->rd_rel->relam)
+		{
+			case HEAP_TABLE_AM_OID:
+				SetupPageCompressForRelation(relation, &((StdRdOptions *)(relation->rd_options))->compress);
+				break;
+
+			case BTREE_AM_OID:
+				SetupPageCompressForRelation(relation, &((BTOptions *)(relation->rd_options))->compress);
+				break;
+
+			case HASH_AM_OID:
+				SetupPageCompressForRelation(relation, &((HashOptions *)(relation->rd_options))->compress);
+				break;
+
+			case GIN_AM_OID:
+				SetupPageCompressForRelation(relation, &((GinOptions *)(relation->rd_options))->compress);
+				break;
+
+			case GIST_AM_OID:
+				SetupPageCompressForRelation(relation, &((GiSTOptions *)(relation->rd_options))->compress);
+				break;
+
+			case SPGIST_AM_OID:
+				SetupPageCompressForRelation(relation, &((SpGistOptions *)(relation->rd_options))->compress);
+				break;
+
+			default:
+				break;
+		}
+	}
 }
 
 /*
@@ -3350,7 +3390,8 @@ RelationBuildLocalRelation(const char *relname,
 						   bool shared_relation,
 						   bool mapped_relation,
 						   char relpersistence,
-						   char relkind)
+						   char relkind,
+						   Datum reloptions)
 {
 	Relation	rel;
 	MemoryContext oldcxt;
@@ -3527,6 +3568,16 @@ RelationBuildLocalRelation(const char *relname,
 
 	RelationInitPhysicalAddr(rel);
 
+	/* setup page compress option */
+	if (reloptions &&
+		(relkind == RELKIND_RELATION ||
+		 relkind == RELKIND_MATVIEW ||
+		 relkind == RELKIND_INDEX))
+		{
+			StdRdOptions *options = (StdRdOptions *)default_reloptions(reloptions, false, RELOPT_KIND_HEAP);
+			SetupPageCompressForRelation(rel, &options->compress);
+		}
+
 	rel->rd_rel->relam = accessmtd;
 
 	if (relkind == RELKIND_RELATION ||
@@ -6404,3 +6455,46 @@ unlink_initfile(const char *initfilename, int elevel)
 							initfilename)));
 	}
 }
+
+/* setup page compress options for relation */
+static void
+SetupPageCompressForRelation(Relation relation, PageCompressOpts *compress_options)
+{
+	if(compress_options->compresstype == COMPRESS_TYPE_NONE)
+	{
+		relation->rd_node.compress_algorithm = COMPRESS_TYPE_NONE;
+		relation->rd_node.compresslevel = 0;
+		relation->rd_node.compress_chunk_size = 0;
+		relation->rd_node.compress_prealloc_chunks = 0;
+	}
+	else
+	{
+		if(!SUPPORT_PAGE_COMPRESSION)
+			elog(ERROR, "unsupported page compression on this platform");
+
+#ifndef USE_ZSTD
+		if(compress_options->compresstype == COMPRESS_TYPE_ZSTD)
+			elog(ERROR, "unsupported compression algorithm %s","zstd");
+#endif
+
+		relation->rd_node.compress_algorithm = compress_options->compresstype;
+		relation->rd_node.compresslevel = compress_options->compresslevel;
+
+		if(compress_options->compress_chunk_size != BLCKSZ / 2 &&
+			compress_options->compress_chunk_size != BLCKSZ / 4 &&
+			compress_options->compress_chunk_size != BLCKSZ / 8)
+			{
+				elog(ERROR, "invalid compress_chunk_size %d , must be one of %d, %d or %d for %s",
+					compress_options->compress_chunk_size,
+					BLCKSZ / 8, BLCKSZ / 4, BLCKSZ / 2,
+					RelationGetRelationName(relation));
+			}
+
+		relation->rd_node.compress_chunk_size = compress_options->compress_chunk_size;
+
+		if(compress_options->compress_prealloc_chunks >= BLCKSZ / compress_options->compress_chunk_size)
+			relation->rd_node.compress_prealloc_chunks = (uint8)(BLCKSZ / compress_options->compress_chunk_size - 1);
+		else
+			relation->rd_node.compress_prealloc_chunks = (uint8)(compress_options->compress_prealloc_chunks);
+	}
+}
\ No newline at end of file
diff --git a/src/backend/utils/cache/spccache.c b/src/backend/utils/cache/spccache.c
index e0c3c1b1c1..fed9074a36 100644
--- a/src/backend/utils/cache/spccache.c
+++ b/src/backend/utils/cache/spccache.c
@@ -235,3 +235,18 @@ get_tablespace_maintenance_io_concurrency(Oid spcid)
 	else
 		return spc->opts->maintenance_io_concurrency;
 }
+
+/*
+ * get_tablespace_compression_option
+ *
+ */
+PageCompressOpts *
+get_tablespace_compression_option(Oid spcid)
+{
+	TableSpaceCacheEntry *spc = get_tablespace(spcid);
+
+	if (!spc->opts)
+		return NULL;
+	else
+		return &spc->opts->compress;
+}
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index 596bcb7b84..065c306b7c 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -80,6 +80,7 @@
 #include "storage/fd.h"
 #include "storage/large_object.h"
 #include "storage/pg_shmem.h"
+#include "storage/page_compression.h"
 #include "storage/predicate.h"
 #include "storage/proc.h"
 #include "storage/standby.h"
@@ -759,6 +760,8 @@ const char *const config_group_names[] =
 	gettext_noop("Client Connection Defaults / Other Defaults"),
 	/* LOCK_MANAGEMENT */
 	gettext_noop("Lock Management"),
+	/* COMPRESS_OPTIONS */
+	gettext_noop("Page Compression"),
 	/* COMPAT_OPTIONS */
 	gettext_noop("Version and Platform Compatibility"),
 	/* COMPAT_OPTIONS_PREVIOUS */
@@ -3399,6 +3402,16 @@ static struct config_int ConfigureNamesInt[] =
 		check_huge_page_size, NULL, NULL
 	},
 
+	{
+		{"compress_address_flush_chunks", PGC_SIGHUP, COMPRESS_OPTIONS,
+			gettext_noop("Set the maximum number of chunks allocated between two flush compressed address files."),
+			NULL
+		},
+		&compress_address_flush_chunks,
+		5000, 0, INT_MAX,
+		NULL, NULL, NULL
+	},
+
 	/* End-of-list marker */
 	{
 		{NULL, 0, 0, NULL, NULL}, NULL, 0, 0, 0, NULL, NULL, NULL
diff --git a/src/bin/pg_basebackup/t/010_pg_basebackup.pl b/src/bin/pg_basebackup/t/010_pg_basebackup.pl
index f674a7c94e..afd9ea5395 100644
--- a/src/bin/pg_basebackup/t/010_pg_basebackup.pl
+++ b/src/bin/pg_basebackup/t/010_pg_basebackup.pl
@@ -6,7 +6,7 @@ use File::Basename qw(basename dirname);
 use File::Path qw(rmtree);
 use PostgresNode;
 use TestLib;
-use Test::More tests => 109;
+use Test::More tests => 115;
 
 program_help_ok('pg_basebackup');
 program_version_ok('pg_basebackup');
@@ -88,6 +88,17 @@ my $baseUnloggedPath = $node->safe_psql('postgres',
 ok(-f "$pgdata/${baseUnloggedPath}_init", 'unlogged init fork in base');
 ok(-f "$pgdata/$baseUnloggedPath",        'unlogged main fork in base');
 
+# Create an compressed table to test that pca and pcd file are copied.
+$node->safe_psql('postgres', 'CREATE TABLE base_compressed (id int) WITH(compresstype=pglz)');
+
+my $baseCompressedPath = $node->safe_psql('postgres',
+	q{select pg_relation_filepath('base_compressed')});
+
+# Make sure compressed relation's address and data files exist
+ok(-f "$pgdata/$baseCompressedPath",       'compressed main fork in base');
+ok(-f "$pgdata/${baseCompressedPath}_pca", 'compressed address file in base');
+ok(-f "$pgdata/${baseCompressedPath}_pcd", 'compressed data file in base');
+
 # Create files that look like temporary relations to ensure they are ignored.
 my $postgresOid = $node->safe_psql('postgres',
 	q{select oid from pg_database where datname = 'postgres'});
@@ -147,6 +158,14 @@ ok(-f "$tempdir/backup/${baseUnloggedPath}_init",
 ok( !-f "$tempdir/backup/$baseUnloggedPath",
 	'unlogged main fork not in backup');
 
+# Compressed relation fork's address and data should be copied
+ok(-f "$tempdir/backup/${baseCompressedPath}",
+	'compressed main fork in backup');
+ok(-f "$tempdir/backup/${baseCompressedPath}_pca",
+	'compressed address file in backup');
+ok(-f "$tempdir/backup/${baseCompressedPath}_pcd",
+	'compressed data file in backup');
+
 # Temp relations should not be copied.
 foreach my $filename (@tempRelationFiles)
 {
diff --git a/src/bin/pg_checksums/pg_checksums.c b/src/bin/pg_checksums/pg_checksums.c
index ffdc23945c..e3837a8461 100644
--- a/src/bin/pg_checksums/pg_checksums.c
+++ b/src/bin/pg_checksums/pg_checksums.c
@@ -29,6 +29,8 @@
 #include "storage/bufpage.h"
 #include "storage/checksum.h"
 #include "storage/checksum_impl.h"
+#include "storage/page_compression.h"
+#include "storage/page_compression_impl.h"
 
 
 static int64 files = 0;
@@ -188,18 +190,70 @@ skipfile(const char *fn)
 }
 
 static void
-scan_file(const char *fn, BlockNumber segmentno)
+scan_file(const char *fn, BlockNumber segmentno, bool is_compressed_datafile)
 {
 	PGAlignedBlock buf;
 	PageHeader	header = (PageHeader) buf.data;
-	int			f;
+	int			f, f_pca;
 	BlockNumber blockno;
 	int			flags;
+	char		fn_pca[MAXPGPATH];
+	PageCompressHeader	*pcMap;
 
 	Assert(mode == PG_MODE_ENABLE ||
 		   mode == PG_MODE_CHECK);
 
+	/* init memory map of compression page address file */
+	if(is_compressed_datafile)
+	{
+		int					r;
+		PageCompressHeader	pchdr;
+
+		strlcpy(fn_pca, fn, sizeof(fn_pca));
+		fn_pca[strlen(fn_pca) -1] = 'a';
+
+		f_pca = open(fn_pca, PG_BINARY | O_RDONLY, 0);
+
+		if (f_pca < 0)
+		{
+			pg_log_error("could not open file \"%s\": %m", fn_pca);
+			exit(1);
+		}
+
+		r = read(f_pca, &pchdr, sizeof(PageCompressHeader));
+		if(r != sizeof(PageCompressHeader))
+		{
+			if (r < 0)
+				pg_log_error("could not read page compression address file head in file \"%s\": %m",
+							fn_pca);
+			else
+				pg_log_error("could not read page compression address file head in file \"%s\": read %d of %d",
+							fn_pca, r, (int)sizeof(PageCompressHeader));
+			exit(1);
+		}
+
+		if(pchdr.chunk_size != BLCKSZ / 2 &&
+		   pchdr.chunk_size != BLCKSZ / 4 &&
+		   pchdr.chunk_size != BLCKSZ / 8)
+		{
+			pg_log_error("the page compression address file head is corrupted in file \"%s\"",
+						fn_pca);
+			exit(1);
+		}
+
+		pcMap = pc_mmap(f_pca, pchdr.chunk_size, true);
+		if(pcMap == MAP_FAILED)
+		{
+			pg_log_error("Failed to mmap page compression address file %s: %m",
+						fn_pca);
+			exit(1);
+		}
+
+		close(f_pca);
+	}
+
 	flags = (mode == PG_MODE_ENABLE) ? O_RDWR : O_RDONLY;
+
 	f = open(fn, PG_BINARY | flags, 0);
 
 	if (f < 0)
@@ -213,19 +267,120 @@ scan_file(const char *fn, BlockNumber segmentno)
 	for (blockno = 0;; blockno++)
 	{
 		uint16		csum;
-		int			r = read(f, buf.data, BLCKSZ);
+		int			r;
+		off_t		first_pc_chunk_pos;
 
-		if (r == 0)
-			break;
-		if (r != BLCKSZ)
+		if(is_compressed_datafile)
 		{
-			if (r < 0)
-				pg_log_error("could not read block %u in file \"%s\": %m",
-							 blockno, fn);
-			else
-				pg_log_error("could not read block %u in file \"%s\": read %d of %d",
-							 blockno, fn, r, BLCKSZ);
-			exit(1);
+			PGAlignedBlock		pcd_buf;
+			int					nbytes,i,read_amount,range;
+			off_t				seekpos;
+			char				*buffer_pos;
+			PageCompressAddr	*pcAddr;
+			bool				is_compressed_block = true;
+
+			if(blockno >= pcMap->nblocks)
+				break;
+
+			pcAddr = GetPageCompressAddr(pcMap, pcMap->chunk_size, blockno);
+
+			/* New pages have no checksum yet */
+			if(pcAddr->nchunks == 0)
+			{
+				blocks++;
+				continue;
+			}
+
+			if(pcAddr->nchunks == BLCKSZ / pcMap->chunk_size)
+				is_compressed_block = false;
+
+			for(i=0; i< pcAddr->nchunks; i++)
+			{
+				if(is_compressed_block)
+					buffer_pos = pcd_buf.data + pcMap->chunk_size * i;
+				else
+					buffer_pos = buf.data + pcMap->chunk_size * i;
+
+				seekpos = (off_t) OffsetOfPageCompressChunk(pcMap->chunk_size, pcAddr->chunknos[i]);
+				if(i == 0)
+					first_pc_chunk_pos = seekpos;
+
+				range = 1;
+				while(i < pcAddr->nchunks - 1 && pcAddr->chunknos[i + 1] == pcAddr->chunknos[i] + 1)
+				{
+					range++;
+					i++;
+				}
+				read_amount = pcMap->chunk_size * range;
+
+				if (lseek(f, seekpos, SEEK_SET) < 0)
+				{
+					pg_log_error("seek failed for block %u in file \"%s\": %m", blockno, fn);
+					exit(1);
+				}
+
+				nbytes = read(f, buffer_pos, read_amount);
+
+				if (nbytes != read_amount)
+				{
+					if (nbytes < 0)
+						pg_log_error("could not read block %u in file \"%s\": %m",
+									blockno, fn);
+					else
+						pg_log_error("could not read block %u in file \"%s\": read %d of %d",
+									blockno, fn, nbytes, read_amount);
+					exit(1);
+				}
+			}
+
+			r = pcMap->chunk_size * pcAddr->nchunks;
+
+			/* decompress chunk data */
+			if(is_compressed_block)
+			{
+				nbytes = decompress_page(pcd_buf.data, buf.data, pcMap->algorithm);
+				if (nbytes != BLCKSZ)
+				{
+					if(nbytes == -2)
+					{
+						pg_log_error("could not recognized compression algorithm %d for file \"%s\"",
+									pcMap->algorithm, fn);
+						exit(1);
+					}
+					else
+					{
+						pg_log_error("could not decompress block %u in file \"%s\": decompress %d of %d bytes",
+									blockno, fn, nbytes, BLCKSZ);
+
+						if(mode == PG_MODE_ENABLE)
+							exit(1);
+						else
+						{
+							blocks++;
+							badblocks++;
+							current_size += r;
+							continue;
+						}
+					}
+				}
+			}
+		}
+		else
+		{
+			r = read(f, buf.data, BLCKSZ);
+
+			if (r == 0)
+				break;
+			if (r != BLCKSZ)
+			{
+				if (r < 0)
+					pg_log_error("could not read block %u in file \"%s\": %m",
+								blockno, fn);
+				else
+					pg_log_error("could not read block %u in file \"%s\": read %d of %d",
+								blockno, fn, r, BLCKSZ);
+				exit(1);
+			}
 		}
 		blocks++;
 
@@ -252,24 +407,49 @@ scan_file(const char *fn, BlockNumber segmentno)
 			/* Set checksum in page header */
 			header->pd_checksum = csum;
 
-			/* Seek back to beginning of block */
-			if (lseek(f, -BLCKSZ, SEEK_CUR) < 0)
+			if(is_compressed_datafile)
 			{
-				pg_log_error("seek failed for block %u in file \"%s\": %m", blockno, fn);
-				exit(1);
-			}
+				/* Seek back to beginning of first chunk */
+				if (lseek(f, first_pc_chunk_pos, SEEK_SET) < 0)
+				{
+					pg_log_error("seek failed for block %u in file \"%s\": %m", blockno, fn);
+					exit(1);
+				}
 
-			/* Write block with checksum */
-			w = write(f, buf.data, BLCKSZ);
-			if (w != BLCKSZ)
+				/* Write block with checksum */
+				w = write(f, header, sizeof(PageHeaderData));
+				if (w != sizeof(PageHeaderData))
+				{
+					if (w < 0)
+						pg_log_error("could not write block %u in file \"%s\": %m",
+									blockno, fn);
+					else
+						pg_log_error("could not write block %u in file \"%s\": wrote %d of %d",
+									blockno, fn, w, (int)sizeof(PageHeaderData));
+					exit(1);
+				}
+			}
+			else
 			{
-				if (w < 0)
-					pg_log_error("could not write block %u in file \"%s\": %m",
-								 blockno, fn);
-				else
-					pg_log_error("could not write block %u in file \"%s\": wrote %d of %d",
-								 blockno, fn, w, BLCKSZ);
-				exit(1);
+				/* Seek back to beginning of block */
+				if (lseek(f, -BLCKSZ, SEEK_CUR) < 0)
+				{
+					pg_log_error("seek failed for block %u in file \"%s\": %m", blockno, fn);
+					exit(1);
+				}
+
+				/* Write block with checksum */
+				w = write(f, buf.data, BLCKSZ);
+				if (w != BLCKSZ)
+				{
+					if (w < 0)
+						pg_log_error("could not write block %u in file \"%s\": %m",
+									blockno, fn);
+					else
+						pg_log_error("could not write block %u in file \"%s\": wrote %d of %d",
+									blockno, fn, w, BLCKSZ);
+					exit(1);
+				}
 			}
 		}
 
@@ -286,6 +466,8 @@ scan_file(const char *fn, BlockNumber segmentno)
 	}
 
 	close(f);
+	if(is_compressed_datafile)
+		pc_munmap(pcMap);
 }
 
 /*
@@ -343,17 +525,32 @@ scan_directory(const char *basedir, const char *subdir, bool sizeonly)
 			char	   *forkpath,
 					   *segmentpath;
 			BlockNumber segmentno = 0;
+			size_t		filenamelength;
+			bool		is_compressed_datafile = false;
+
 
 			if (skipfile(de->d_name))
 				continue;
 
+			/* check if is compressed page file */
+			strlcpy(fnonly, de->d_name, sizeof(fnonly));
+			filenamelength = strlen(fnonly);
+			if(filenamelength >= 4)
+			{
+				if(strncmp(fnonly + filenamelength - 4, "_pca", 4) == 0)
+					continue;
+				else if(strncmp(fnonly + filenamelength - 4, "_pcd", 4) == 0)
+				{
+					is_compressed_datafile = true;
+					fnonly[filenamelength - 4] = '\0';
+				}
+			}
 			/*
 			 * Cut off at the segment boundary (".") to get the segment number
 			 * in order to mix it into the checksum. Then also cut off at the
 			 * fork boundary, to get the filenode the file belongs to for
 			 * filtering.
 			 */
-			strlcpy(fnonly, de->d_name, sizeof(fnonly));
 			segmentpath = strchr(fnonly, '.');
 			if (segmentpath != NULL)
 			{
@@ -382,7 +579,7 @@ scan_directory(const char *basedir, const char *subdir, bool sizeonly)
 			 * the items in the data folder.
 			 */
 			if (!sizeonly)
-				scan_file(fn, segmentno);
+				scan_file(fn, segmentno, is_compressed_datafile);
 		}
 #ifndef WIN32
 		else if (S_ISDIR(st.st_mode) || S_ISLNK(st.st_mode))
